---
title: Dynamic Appearance Customization
product: Survey Creator
description: Explore theme customization capabilities of Survey Creator, an extensible JavaScript form builder. Learn how to apply predefined themes like Light, Dark, Contrast, and Survey Creator 2020, or create your own theme by overriding the CSS variables of the available themes. Save and persist customizations in localStorage for easy restoration on future visits.
framework: Vanilla JS
source: https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/vanillajs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Dynamic Appearance Customization (Vanilla JS)

Survey Creator allows users to dynamically customize the colors and sizes of its UI elements. These customizations can be saved as a theme and reapplied on subsequent visits. Survey Creator comes with four predefined themes to kick-start the customization process: Light, Dark, Contrast, and Survey Creator 2020. By default, this demo uses the Contrast theme. You can choose a different theme, adjust colors and sizes, and click "Persist the UI theme" to save your customizations. The theme will be stored in the browser's `localStorage` and automatically restored when you reload the page.

## Add Predefined Themes to Survey Creator

By default, users can customize only the Light theme. To make other predefined themes available for customization, import an object with predefined theme configurations or reference a script with it and pass the object to the static `registerCreatorTheme()` method:

**Modular applications**

```js
import SurveyCreatorTheme from "survey-creator-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyCreatorTheme);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <script src="https://unpkg.com/survey-creator-core/themes/index.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        SurveyCreatorCore.registerCreatorTheme(SurveyCreatorTheme);
    </script>
</body>
```

If you want to add only specific predefined themes, use the following code:

**Modular applications**

```js
import {
    SC2020,
    DefaultDark,
    DefaultContrast
} from "survey-creator-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SC2020, DefaultDark, DefaultContrast);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <script src="https://unpkg.com/survey-creator-core/themes/sc2020.min.js"></script>
    <script src="https://unpkg.com/survey-creator-core/themes/default-dark.min.js"></script>
    <script src="https://unpkg.com/survey-creator-core/themes/default-contrast.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        SurveyCreatorCore.registerCreatorTheme(
            SurveyCreatorTheme.SC2020,
            SurveyCreatorTheme.DefaultDark,
            SurveyCreatorTheme.DefaultContrast
        );
    </script>
</body>
```  

## Apply a Predefined Theme in Code

The Light theme is applied with the `survey-creator-core.css` style sheet. All other themes are defined as JSON objects that contain a unique theme identifier and a nested object with CSS variables that override the corresponding variables in the Light theme. To apply the Dark, Contrast, or Survey Creator 2020 theme, import or reference it and pass the theme JSON object to the [`applyCreatorTheme(theme)`](/survey-creator/documentation/api-reference/survey-creator#applyCreatorTheme) method on a `SurveyCreatorModel` instance:

**Modular applications**

```js
// Option 1: Import an individual theme
import { SC2020 } from "survey-creator-core/themes";
// import { DefaultDark } from "survey-creator-core/themes";
// import { DefaultContrast } from "survey-creator-core/themes";

const creatorOptions = { /* ... */ };
const creator = new SurveyCreatorModel(creatorOptions);
creator.applyCreatorTheme(SC2020);
```

```js
// Option 2: Import all themes
import SurveyCreatorTheme from "survey-creator-core/themes";

const creatorOptions = { /* ... */ };
const creator = new SurveyCreatorModel(creatorOptions);
creator.applyCreatorTheme(SurveyCreatorTheme.SC2020);
// creator.applyCreatorTheme(SurveyCreatorTheme.DefaultDark);
// creator.applyCreatorTheme(SurveyCreatorTheme.DefaultContrast);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <!-- Option 1: Reference an individual theme -->
    <script src="https://unpkg.com/survey-creator-core/themes/sc2020.min.js"></script>
    <!-- <script src="https://unpkg.com/survey-creator-core/themes/default-dark.min.js"></script> -->
    <!-- <script src="https://unpkg.com/survey-creator-core/themes/default-contrast.min.js"></script> -->

    <!-- Option 2: Reference all themes -->
    <script src="https://unpkg.com/survey-creator-core/themes/index.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        const creatorOptions = { /* ... */ };
        const creator = new SurveyCreatorModel(creatorOptions);
        creator.applyCreatorTheme(SurveyCreatorTheme.SC2020);
        // creator.applyCreatorTheme(SurveyCreatorTheme.DefaultDark);
        // creator.applyCreatorTheme(SurveyCreatorTheme.DefaultContrast);
    </script>
</body>
```

## Save and Restore User-Made Customizations

You can save theme customizations made by a user in the browser's `localStorage` and restore them next time the user opens Survey Creator. To access the theme JSON object, use the `SurveyCreatorModel`'s [`creatorTheme`](/survey-creator/documentation/api-reference/survey-creator#creatorTheme) property. Convert this object to string and save the result to the `localStorage`.

In this demo, a custom theme is saved when users click the "Persist the UI theme" toolbar button. To configure it, define an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) object and pass it to the `Action` constructor. Refer to the Code tab for a code listing.

As an alternative, a custom theme can be saved automatically when a user changes it. To implement this functionality, handle the [`onCreatorThemePropertyChanged`](/survey-creator/documentation/api-reference/survey-creator#onCreatorThemePropertyChanged) event as follows:

```js
creator.onCreatorThemePropertyChanged.add(() => {
    const themeStr = JSON.stringify(creator.creatorTheme);
    localStorage.setItem(localStorageKey, themeStr);
});
```

## Disable Theme Customization

If you want to disable the ability for users to customize the Survey Creator UI, set the [`showCreatorThemeSettings`](/survey-creator/documentation/api-reference/icreatoroptions#showCreatorThemeSettings) property to `false`:

```js
// Option 1: Disable theme customization before instantiating Survey Creator
const creatorOptions = {
    // ...
    showCreatorThemeSettings: false
}
const creator = new SurveyCreatorModel(creatorOptions);

// Option 2: Disable theme customization at runtime
creator.showCreatorThemeSettings = false;
```

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { SurveyCreator } from "survey-creator-js";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { ComputedUpdater, Action } from "survey-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

const creator = new SurveyCreator();

const localStorageKey = "userSurveyCreatorTheme";
const savedTheme = localStorage.getItem(localStorageKey);
creator.applyCreatorTheme(savedTheme ? JSON.parse(savedTheme) : SurveyTheme.DefaultContrast);

const saveTheme = () => {
    const themeStr = JSON.stringify(creator.creatorTheme);
    localStorage.setItem(localStorageKey, themeStr);
};

const saveThemeAction = new Action({
    id: "svd-save-theme-settings",
    iconName: "icon-save-24x24",
    iconSize: "auto",
    tooltip: "Persist the UI theme",
    visible: new ComputedUpdater(() => {
        return creator.activeTab === "designer" && creator.propertyGridNavigationMode === "buttons" && creator.showCreatorThemeSettings;
    }),
    enabled: true,
    action: saveTheme
});

const resetTheme = () => {
    window.localStorage.setItem(localStorageKey, "");
    location.reload();
};

const resetThemeAction = new Action({
    id: "svd-reset-theme",
    iconName: "icon-restore-24x24",
    iconSize: "auto",
    tooltip: "Reset the UI theme",
    visible: new ComputedUpdater(() => {
        return creator.activeTab === "designer" && creator.propertyGridNavigationMode === "buttons" && creator.showCreatorThemeSettings;
    }),
    enabled: true,
    action: resetTheme
});

creator.toolbar.actions.push(resetThemeAction);

creator.toolbar.actions.push(saveThemeAction);

creator.showSidebar = false;
setTimeout(() => {
    creator.openCreatorThemeSettings();
}, 400);
creator.render("surveyCreatorContainer");
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-js": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/angular.md)
- [React](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/jquery.md)


---
title: Dynamic Appearance Customization
product: Survey Creator
description: Explore theme customization capabilities of Survey Creator, an extensible JavaScript form builder. Learn how to apply predefined themes like Light, Dark, Contrast, and Survey Creator 2020, or create your own theme by overriding the CSS variables of the available themes. Save and persist customizations in localStorage for easy restoration on future visits.
framework: React
source: https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Dynamic Appearance Customization (React)

Survey Creator allows users to dynamically customize the colors and sizes of its UI elements. These customizations can be saved as a theme and reapplied on subsequent visits. Survey Creator comes with four predefined themes to kick-start the customization process: Light, Dark, Contrast, and Survey Creator 2020. By default, this demo uses the Contrast theme. You can choose a different theme, adjust colors and sizes, and click "Persist the UI theme" to save your customizations. The theme will be stored in the browser's `localStorage` and automatically restored when you reload the page.

## Add Predefined Themes to Survey Creator

By default, users can customize only the Light theme. To make other predefined themes available for customization, import an object with predefined theme configurations or reference a script with it and pass the object to the static `registerCreatorTheme()` method:

**Modular applications**

```js
import SurveyCreatorTheme from "survey-creator-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyCreatorTheme);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <script src="https://unpkg.com/survey-creator-core/themes/index.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        SurveyCreatorCore.registerCreatorTheme(SurveyCreatorTheme);
    </script>
</body>
```

If you want to add only specific predefined themes, use the following code:

**Modular applications**

```js
import {
    SC2020,
    DefaultDark,
    DefaultContrast
} from "survey-creator-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SC2020, DefaultDark, DefaultContrast);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <script src="https://unpkg.com/survey-creator-core/themes/sc2020.min.js"></script>
    <script src="https://unpkg.com/survey-creator-core/themes/default-dark.min.js"></script>
    <script src="https://unpkg.com/survey-creator-core/themes/default-contrast.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        SurveyCreatorCore.registerCreatorTheme(
            SurveyCreatorTheme.SC2020,
            SurveyCreatorTheme.DefaultDark,
            SurveyCreatorTheme.DefaultContrast
        );
    </script>
</body>
```  

## Apply a Predefined Theme in Code

The Light theme is applied with the `survey-creator-core.css` style sheet. All other themes are defined as JSON objects that contain a unique theme identifier and a nested object with CSS variables that override the corresponding variables in the Light theme. To apply the Dark, Contrast, or Survey Creator 2020 theme, import or reference it and pass the theme JSON object to the [`applyCreatorTheme(theme)`](/survey-creator/documentation/api-reference/survey-creator#applyCreatorTheme) method on a `SurveyCreatorModel` instance:

**Modular applications**

```js
// Option 1: Import an individual theme
import { SC2020 } from "survey-creator-core/themes";
// import { DefaultDark } from "survey-creator-core/themes";
// import { DefaultContrast } from "survey-creator-core/themes";

const creatorOptions = { /* ... */ };
const creator = new SurveyCreatorModel(creatorOptions);
creator.applyCreatorTheme(SC2020);
```

```js
// Option 2: Import all themes
import SurveyCreatorTheme from "survey-creator-core/themes";

const creatorOptions = { /* ... */ };
const creator = new SurveyCreatorModel(creatorOptions);
creator.applyCreatorTheme(SurveyCreatorTheme.SC2020);
// creator.applyCreatorTheme(SurveyCreatorTheme.DefaultDark);
// creator.applyCreatorTheme(SurveyCreatorTheme.DefaultContrast);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <!-- Option 1: Reference an individual theme -->
    <script src="https://unpkg.com/survey-creator-core/themes/sc2020.min.js"></script>
    <!-- <script src="https://unpkg.com/survey-creator-core/themes/default-dark.min.js"></script> -->
    <!-- <script src="https://unpkg.com/survey-creator-core/themes/default-contrast.min.js"></script> -->

    <!-- Option 2: Reference all themes -->
    <script src="https://unpkg.com/survey-creator-core/themes/index.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        const creatorOptions = { /* ... */ };
        const creator = new SurveyCreatorModel(creatorOptions);
        creator.applyCreatorTheme(SurveyCreatorTheme.SC2020);
        // creator.applyCreatorTheme(SurveyCreatorTheme.DefaultDark);
        // creator.applyCreatorTheme(SurveyCreatorTheme.DefaultContrast);
    </script>
</body>
```

## Save and Restore User-Made Customizations

You can save theme customizations made by a user in the browser's `localStorage` and restore them next time the user opens Survey Creator. To access the theme JSON object, use the `SurveyCreatorModel`'s [`creatorTheme`](/survey-creator/documentation/api-reference/survey-creator#creatorTheme) property. Convert this object to string and save the result to the `localStorage`.

In this demo, a custom theme is saved when users click the "Persist the UI theme" toolbar button. To configure it, define an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) object and pass it to the `Action` constructor. Refer to the Code tab for a code listing.

As an alternative, a custom theme can be saved automatically when a user changes it. To implement this functionality, handle the [`onCreatorThemePropertyChanged`](/survey-creator/documentation/api-reference/survey-creator#onCreatorThemePropertyChanged) event as follows:

```js
creator.onCreatorThemePropertyChanged.add(() => {
    const themeStr = JSON.stringify(creator.creatorTheme);
    localStorage.setItem(localStorageKey, themeStr);
});
```

## Disable Theme Customization

If you want to disable the ability for users to customize the Survey Creator UI, set the [`showCreatorThemeSettings`](/survey-creator/documentation/api-reference/icreatoroptions#showCreatorThemeSettings) property to `false`:

```js
// Option 1: Disable theme customization before instantiating Survey Creator
const creatorOptions = {
    // ...
    showCreatorThemeSettings: false
}
const creator = new SurveyCreatorModel(creatorOptions);

// Option 2: Disable theme customization at runtime
creator.showCreatorThemeSettings = false;
```

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { ComputedUpdater, Action } from "survey-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator();
    const localStorageKey = "userSurveyCreatorTheme";
    const savedTheme = localStorage.getItem(localStorageKey);
    creator.applyCreatorTheme(savedTheme ? JSON.parse(savedTheme) : SurveyTheme.DefaultContrast);
    
    const saveTheme = () => {
        const themeStr = JSON.stringify(creator.creatorTheme);
        localStorage.setItem(localStorageKey, themeStr);
    };
    
    const saveThemeAction = new Action({
        id: "svd-save-theme-settings",
        iconName: "icon-save-24x24",
        iconSize: "auto",
        tooltip: "Persist the UI theme",
        visible: new ComputedUpdater(() => {
            return creator.activeTab === "designer" && creator.propertyGridNavigationMode === "buttons" && creator.showCreatorThemeSettings;
        }),
        enabled: true,
        action: saveTheme
    });
    
    const resetTheme = () => {
        window.localStorage.setItem(localStorageKey, "");
        location.reload();
    };
    
    const resetThemeAction = new Action({
        id: "svd-reset-theme",
        iconName: "icon-restore-24x24",
        iconSize: "auto",
        tooltip: "Reset the UI theme",
        visible: new ComputedUpdater(() => {
            return creator.activeTab === "designer" && creator.propertyGridNavigationMode === "buttons" && creator.showCreatorThemeSettings;
        }),
        enabled: true,
        action: resetTheme
    });
    
    creator.toolbar.actions.push(resetThemeAction);
    
    creator.toolbar.actions.push(saveThemeAction);
    
    creator.showSidebar = false;
    setTimeout(() => {
        creator.openCreatorThemeSettings();
    }, 400);
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/vanillajs.md)


---
title: Dynamic Appearance Customization
product: Survey Creator
description: Explore theme customization capabilities of Survey Creator, an extensible JavaScript form builder. Learn how to apply predefined themes like Light, Dark, Contrast, and Survey Creator 2020, or create your own theme by overriding the CSS variables of the available themes. Save and persist customizations in localStorage for easy restoration on future visits.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Dynamic Appearance Customization (Angular)

Survey Creator allows users to dynamically customize the colors and sizes of its UI elements. These customizations can be saved as a theme and reapplied on subsequent visits. Survey Creator comes with four predefined themes to kick-start the customization process: Light, Dark, Contrast, and Survey Creator 2020. By default, this demo uses the Contrast theme. You can choose a different theme, adjust colors and sizes, and click "Persist the UI theme" to save your customizations. The theme will be stored in the browser's `localStorage` and automatically restored when you reload the page.

## Add Predefined Themes to Survey Creator

By default, users can customize only the Light theme. To make other predefined themes available for customization, import an object with predefined theme configurations or reference a script with it and pass the object to the static `registerCreatorTheme()` method:

**Modular applications**

```js
import SurveyCreatorTheme from "survey-creator-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyCreatorTheme);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <script src="https://unpkg.com/survey-creator-core/themes/index.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        SurveyCreatorCore.registerCreatorTheme(SurveyCreatorTheme);
    </script>
</body>
```

If you want to add only specific predefined themes, use the following code:

**Modular applications**

```js
import {
    SC2020,
    DefaultDark,
    DefaultContrast
} from "survey-creator-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SC2020, DefaultDark, DefaultContrast);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <script src="https://unpkg.com/survey-creator-core/themes/sc2020.min.js"></script>
    <script src="https://unpkg.com/survey-creator-core/themes/default-dark.min.js"></script>
    <script src="https://unpkg.com/survey-creator-core/themes/default-contrast.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        SurveyCreatorCore.registerCreatorTheme(
            SurveyCreatorTheme.SC2020,
            SurveyCreatorTheme.DefaultDark,
            SurveyCreatorTheme.DefaultContrast
        );
    </script>
</body>
```  

## Apply a Predefined Theme in Code

The Light theme is applied with the `survey-creator-core.css` style sheet. All other themes are defined as JSON objects that contain a unique theme identifier and a nested object with CSS variables that override the corresponding variables in the Light theme. To apply the Dark, Contrast, or Survey Creator 2020 theme, import or reference it and pass the theme JSON object to the [`applyCreatorTheme(theme)`](/survey-creator/documentation/api-reference/survey-creator#applyCreatorTheme) method on a `SurveyCreatorModel` instance:

**Modular applications**

```js
// Option 1: Import an individual theme
import { SC2020 } from "survey-creator-core/themes";
// import { DefaultDark } from "survey-creator-core/themes";
// import { DefaultContrast } from "survey-creator-core/themes";

const creatorOptions = { /* ... */ };
const creator = new SurveyCreatorModel(creatorOptions);
creator.applyCreatorTheme(SC2020);
```

```js
// Option 2: Import all themes
import SurveyCreatorTheme from "survey-creator-core/themes";

const creatorOptions = { /* ... */ };
const creator = new SurveyCreatorModel(creatorOptions);
creator.applyCreatorTheme(SurveyCreatorTheme.SC2020);
// creator.applyCreatorTheme(SurveyCreatorTheme.DefaultDark);
// creator.applyCreatorTheme(SurveyCreatorTheme.DefaultContrast);
```

**Classic script applications**

```html
<head>
    <!-- ... -->
    <!-- Option 1: Reference an individual theme -->
    <script src="https://unpkg.com/survey-creator-core/themes/sc2020.min.js"></script>
    <!-- <script src="https://unpkg.com/survey-creator-core/themes/default-dark.min.js"></script> -->
    <!-- <script src="https://unpkg.com/survey-creator-core/themes/default-contrast.min.js"></script> -->

    <!-- Option 2: Reference all themes -->
    <script src="https://unpkg.com/survey-creator-core/themes/index.min.js"></script>
    <!-- ... -->
</head>
<body>
    <script>
        const creatorOptions = { /* ... */ };
        const creator = new SurveyCreatorModel(creatorOptions);
        creator.applyCreatorTheme(SurveyCreatorTheme.SC2020);
        // creator.applyCreatorTheme(SurveyCreatorTheme.DefaultDark);
        // creator.applyCreatorTheme(SurveyCreatorTheme.DefaultContrast);
    </script>
</body>
```

## Save and Restore User-Made Customizations

You can save theme customizations made by a user in the browser's `localStorage` and restore them next time the user opens Survey Creator. To access the theme JSON object, use the `SurveyCreatorModel`'s [`creatorTheme`](/survey-creator/documentation/api-reference/survey-creator#creatorTheme) property. Convert this object to string and save the result to the `localStorage`.

In this demo, a custom theme is saved when users click the "Persist the UI theme" toolbar button. To configure it, define an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) object and pass it to the `Action` constructor. Refer to the Code tab for a code listing.

As an alternative, a custom theme can be saved automatically when a user changes it. To implement this functionality, handle the [`onCreatorThemePropertyChanged`](/survey-creator/documentation/api-reference/survey-creator#onCreatorThemePropertyChanged) event as follows:

```js
creator.onCreatorThemePropertyChanged.add(() => {
    const themeStr = JSON.stringify(creator.creatorTheme);
    localStorage.setItem(localStorageKey, themeStr);
});
```

## Disable Theme Customization

If you want to disable the ability for users to customize the Survey Creator UI, set the [`showCreatorThemeSettings`](/survey-creator/documentation/api-reference/icreatoroptions#showCreatorThemeSettings) property to `false`:

```js
// Option 1: Disable theme customization before instantiating Survey Creator
const creatorOptions = {
    // ...
    showCreatorThemeSettings: false
}
const creator = new SurveyCreatorModel(creatorOptions);

// Option 2: Disable theme customization at runtime
creator.showCreatorThemeSettings = false;
```

## Files

### `src/app/components/creator.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { ComputedUpdater, Action } from "survey-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel();
        const localStorageKey = "userSurveyCreatorTheme";
        const savedTheme = localStorage.getItem(localStorageKey);
        creator.applyCreatorTheme(savedTheme ? JSON.parse(savedTheme) : SurveyTheme.DefaultContrast);
        
        const saveTheme = () => {
            const themeStr = JSON.stringify(creator.creatorTheme);
            localStorage.setItem(localStorageKey, themeStr);
        };
        
        const saveThemeAction = new Action({
            id: "svd-save-theme-settings",
            iconName: "icon-save-24x24",
            iconSize: "auto",
            tooltip: "Persist the UI theme",
            visible: new ComputedUpdater(() => {
                return creator.activeTab === "designer" && creator.propertyGridNavigationMode === "buttons" && creator.showCreatorThemeSettings;
            }),
            enabled: true,
            action: saveTheme
        });
        
        const resetTheme = () => {
            window.localStorage.setItem(localStorageKey, "");
            location.reload();
        };
        
        const resetThemeAction = new Action({
            id: "svd-reset-theme",
            iconName: "icon-restore-24x24",
            iconSize: "auto",
            tooltip: "Reset the UI theme",
            visible: new ComputedUpdater(() => {
                return creator.activeTab === "designer" && creator.propertyGridNavigationMode === "buttons" && creator.showCreatorThemeSettings;
            }),
            enabled: true,
            action: resetTheme
        });
        
        creator.toolbar.actions.push(resetThemeAction);
        
        creator.toolbar.actions.push(saveThemeAction);
        
        creator.showSidebar = false;
        setTimeout(() => {
            creator.openCreatorThemeSettings();
        }, 400);
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/dynamic-ui-customization/vanillajs.md)
